
function mgDisplayResponse(templateId, templateData) {
    var source = $("#" + templateId).html();
    var template = Handlebars.compile(source);
    var html = template(templateData);
    $("#content").html(html);
}

function mgPrepareUrl(addition, base) {
    addition = String(addition).trim();
    base = String(base).trim();
    
    if (base.indexOf('http') > -1) {
        return base + addition;
    } else {
        return 'https://' + base + addition;
    }
}

function mgInitApp () {
    var client = ZAFClient.init();
    client.invoke('resize', { width: '100%', height: '400px' });
    client.get('ticket').then(function(data) {
        var ticketInfo = data.ticket;
        var BreakException = {};
        var brandurl = (ticketInfo.brand && ticketInfo.brand.url) ? ticketInfo.brand.url : null;
        var headers = {};
        var whmcsfinalurl;
        var whmcsurl = "";        

        client.metadata().then(function(metadata) {
            var settingsData = metadata.settings;

            if (settingsData.whmcsurl.search("\n") != -1) {
                try {
                    settingsData.whmcsurl.split("\n").forEach(function (element) {
                        if (brandurl != null) {
                            if (element.search("|") != -1) {
                                if (brandurl == element.split("|")[0]) {
                                    whmcsurl = element.split("|")[1];
                                }
                            } else {
                                whmcsurl = element;
                            }
                        } else {
                            if (element.search("|") != -1) {
                                whmcsurl = element.split("|")[1];
                            } else {
                                whmcsurl = element;
                            }
                            throw BreakException;
                        }
                    });
                } catch (e) {
                    if (e !== BreakException) {
                        throw e;
                    }
                }
            } else {
                if (brandurl == settingsData.whmcsurl.split("|")[0] || brandurl == null) {
                    if (settingsData.whmcsurl.search("|") != -1) {
                        whmcsurl = settingsData.whmcsurl.split("|")[1];
                    } else {
                        whmcsurl = settingsData.whmcsurl;
                    }
                }
            }

            if (whmcsurl.substr(-17) == 'customer_info.php') {
                whmcsfinalurl = whmcsurl;
            } else if (whmcsurl.substr(-1) != '/') {
                whmcsfinalurl = mgPrepareUrl("/includes/zendesk_app/customer_info.php", whmcsurl);
            } else {
                whmcsfinalurl = mgPrepareUrl("includes/zendesk_app/customer_info.php", whmcsurl);
            }
            if (settingsData.whmcsurl.substr(-17) == 'customer_info.php') {
                whmcsfinalurl = settingsData.whmcsurl;
            } else if (settingsData.whmcsurl.substr(-1) != '/') {
                whmcsfinalurl = mgPrepareUrl("/includes/zendesk_app/customer_info.php", settingsData.whmcsurl);
            } else {
                whmcsfinalurl = mgPrepareUrl("includes/zendesk_app/customer_info.php", settingsData.whmcsurl);
            }

            if (settingsData.baseusername && settingsData.basepassword) {
                headers = {"Authorization": "Basic " + btoa(settingsData.baseusername + ":" + "{{setting.basepassword}}")};
            }

            headers.securecode = "{{setting.securecode}}";
            headers.email = ticketInfo.requester.email;

            if (whmcsfinalurl.indexOf("http:") === 0) {
                whmcsfinalurl = whmcsfinalurl.replace("http:", "https:");
            }

            mgLoadData( {
                url: whmcsfinalurl,
                dataType: 'json',
                headers: headers,
                secure: true
            }, settingsData);
    });    
});
}

function mgLoadData(params, settingsData){
    var client = ZAFClient.init();
    client.request(params).then(function (data) {
        var response = {};
        response.info = data;
        if (data.result == 'success') {
            response.success = true;
            response.settings = settingsData;
        } else {
            response.error = true;
            response.message = data.message;
        }
        mgDisplayResponse('info-template', response);
    }).catch(function(error) {
         var response = {
             error: true,
             message: error.responseText
         };
         if (error.status == 401)
         {
             response.message = "HTTP Basic Authentication Error";
         }
         if (error.status == 403)
         {
             response.message = error.responseText + " For: " + params.url;
         }
         if (error.status == 404)
         {
             response.message = "The path does not exist: " + params.url;
         }

         mgDisplayResponse('info-template', response);
    });
}

$(function () {
    var response = {
        showLoader: true
    };
    mgDisplayResponse('info-template', response);
    mgInitApp();
});
